org.apache.lucene.facet.params

## Class PerDimensionIndexingParams

- java.lang.Object
- - org.apache.lucene.facet.params.FacetIndexingParams
  - - org.apache.lucene.facet.params.PerDimensionIndexingParams

    public class PerDimensionIndexingParams
    extends FacetIndexingParams

A `FacetIndexingParams` that utilizes different category lists, defined by the dimension specified by a `category` (see `PerDimensionIndexingParams(Map, CategoryListParams)`.

A 'dimension' is defined as the first or "zero-th" component in a `CategoryPath`. For example, if a category is defined as "Author/American/Mark Twain", then the dimension would be "Author".

WARNING: This API is experimental and might change in incompatible ways in the next release.

### Field Summary

### Fields inherited from class org.apache.lucene.facet.params.FacetIndexingParams

`clParams, DEFAULT, DEFAULT_CATEGORY_LIST_PARAMS, DEFAULT_FACET_DELIM_CHAR`

### Constructor Summary

Constructors
Constructor and Description
`PerDimensionIndexingParams(Map<CategoryPath,CategoryListParams> paramsMap)` Initializes a new instance with the given dimension-to-params mapping.
`PerDimensionIndexingParams(Map<CategoryPath,CategoryListParams> paramsMap, CategoryListParams categoryListParams)` Same as `PerDimensionIndexingParams(Map)`, only the given `CategoryListParams` will be used for any dimension that is not specified in the given mapping.

### Method Summary

Methods
`List<CategoryListParams>` `getAllCategoryListParams()` Returns a list of all `categoryListParams` that are used for facets indexing.
`CategoryListParams` `getCategoryListParams(CategoryPath category)` Returns the `CategoryListParams` for the corresponding dimension which is returned by `category.getComponent(0)`.

### Methods inherited from class org.apache.lucene.facet.params.FacetIndexingParams

`drillDownTermText, equals, getFacetDelimChar, getPartitionSize, hashCode`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PerDimensionIndexingParams

    public PerDimensionIndexingParams(Map<CategoryPath,CategoryListParams> paramsMap)

Initializes a new instance with the given dimension-to-params mapping. The dimension is considered as what's returned by `cp.components[0]`.

NOTE: for any dimension whose `CategoryListParams` is not defined in the mapping, a default `CategoryListParams` will be used.

See Also:
  `PerDimensionIndexingParams(Map, CategoryListParams)`

#### PerDimensionIndexingParams

    public PerDimensionIndexingParams(Map<CategoryPath,CategoryListParams> paramsMap,
                              CategoryListParams categoryListParams)

Same as `PerDimensionIndexingParams(Map)`, only the given `CategoryListParams` will be used for any dimension that is not specified in the given mapping.

### Method Detail

#### getAllCategoryListParams

    public List<CategoryListParams> getAllCategoryListParams()

Description copied from class: `FacetIndexingParams`
Returns a list of all `categoryListParams` that are used for facets indexing.

Overrides:
  `getAllCategoryListParams` in class `FacetIndexingParams`

#### getCategoryListParams

    public CategoryListParams getCategoryListParams(CategoryPath category)

Returns the `CategoryListParams` for the corresponding dimension which is returned by `category.getComponent(0)`. If `category` is `null`, or was not specified in the map given to the constructor, returns the default `CategoryListParams`.

Overrides:
  `getCategoryListParams` in class `FacetIndexingParams`
See Also:
  `PerDimensionIndexingParams`